GetWorkflowStepExecution
Retrieves runtime information for a specific runtime instance of the workflow step.
Request Syntax
GET /GetWorkflowStepExecution?stepExecutionId=stepExecutionId HTTP/1.1
URI Request Parameters
The request uses the following URI parameters.
- stepExecutionId
-
The unique identifier for the runtime instance of the workflow step that you want to get runtime details for. To get the identifiers for the steps that ran in a workflow, call ListWorkflowStepExecutions.
Pattern:
^step-[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$Required: Yes
Request Body
The request does not have a request body.
Response Syntax
HTTP/1.1 200
Content-type: application/json
{
"action": "string",
"attemptNumber": number,
"description": "string",
"endTime": "string",
"imageBuildVersionArn": "string",
"inputs": "string",
"maxAttempts": number,
"message": "string",
"name": "string",
"onFailure": "string",
"outputs": "string",
"requestId": "string",
"rollbackStatus": "string",
"startTime": "string",
"status": "string",
"stepExecutionId": "string",
"timeoutSeconds": number,
"workflowBuildVersionArn": "string",
"workflowExecutionId": "string"
}
Response Elements
If the action is successful, the service sends back an HTTP 200 response.
The following data is returned in JSON format by the service.
- action
-
The name of the action that the specified step performs.
Type: String
Pattern:
^[A-Za-z][A-Za-z0-9-_]{1,99}$ - attemptNumber
-
The current attempt number for the specified runtime instance of the workflow step. The first run is attempt one. The number increases by one for each retry.
Type: Integer
Valid Range: Minimum value of 1.
- description
-
Describes the specified workflow step.
Type: String
Length Constraints: Minimum length of 0. Maximum length of 500.
- endTime
-
The timestamp when the specified runtime instance of the workflow step finished.
Type: String
- imageBuildVersionArn
-
The Amazon Resource Name (ARN) of the image build version that owns the specified runtime instance of the workflow step.
Type: String
Pattern:
^arn:aws[^:]*:imagebuilder:[^:]+:(?:[0-9]{12}|aws(?:-[a-z-]+)?):image/[a-z0-9-_]+/[0-9]+\.[0-9]+\.[0-9]+/[0-9]+$ - inputs
-
Input parameters that Image Builder provided for the specified runtime instance of the workflow step, as a JSON-encoded string.
Type: String
- maxAttempts
-
The maximum number of attempts allowed for the specified runtime instance of the workflow step, based on the retry configuration in the workflow document. If the step doesn't configure retries, the maximum is one attempt.
Type: Integer
Valid Range: Minimum value of 1.
- message
-
The output message from the specified runtime instance of the workflow step, if applicable.
Type: String
Length Constraints: Minimum length of 0. Maximum length of 500.
- name
-
The name of the specified runtime instance of the workflow step.
Type: String
Pattern:
^[A-Za-z][A-Za-z0-9-_]{1,99}$ - onFailure
-
The action that the workflow takes if this step fails, as configured in the workflow document.
Abortfails the workflow and rolls back completed steps.Continueproceeds to the next step. If the step doesn't set a value, it defaults toAbort.Type: String
Length Constraints: Minimum length of 1. Maximum length of 1024.
- outputs
-
The output values that the specified runtime instance of the workflow step produced, as a JSON-encoded string. For example, a step that launches an instance outputs the instance ID. If the step failed, this field contains the error message.
Type: String
- requestId
-
The request ID that uniquely identifies this request.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 1024.
- rollbackStatus
-
Reports on the rollback status of the specified runtime instance of the workflow step, if applicable. Rollback runs when the workflow execution fails, and undoes the work that completed steps performed.
Type: String
Valid Values:
RUNNING | COMPLETED | SKIPPED | FAILED - startTime
-
The timestamp when the specified runtime instance of the workflow step started.
Type: String
- status
-
The current status for the specified runtime instance of the workflow step.
Type: String
Valid Values:
PENDING | SKIPPED | RUNNING | COMPLETED | FAILED | CANCELLED - stepExecutionId
-
The unique identifier for the runtime instance of the workflow step that you specified in the request.
Type: String
Pattern:
^step-[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$ - timeoutSeconds
-
The maximum duration in seconds for this step to complete its action. If the workflow document doesn't set a timeout for the step, Image Builder applies the default timeout for the step's action. This field returns that value.
Type: Integer
Valid Range: Minimum value of 0. Maximum value of 43200.
- workflowBuildVersionArn
-
The Amazon Resource Name (ARN) of the build version for the Image Builder workflow resource that defines this workflow step.
Type: String
Length Constraints: Maximum length of 1024.
Pattern:
^arn:aws(?:-[a-z]+)*:imagebuilder:[a-z]{2,}(?:-[a-z]+)+-[0-9]+:(?:[0-9]{12}|aws(?:-[a-z-]+)?):workflow/(build|test|distribution)/[a-z0-9-_]+/[0-9]+\.[0-9]+\.[0-9]+/[0-9]+$ - workflowExecutionId
-
The unique identifier that Image Builder assigned to keep track of runtime details when it ran the workflow.
Type: String
Pattern:
^wf-[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$
Errors
For information about the errors that are common to all actions, see Common Error Types.
- CallRateLimitExceededException
-
You have exceeded the permitted request rate for the Amazon EC2 APIs that Image Builder calls on your behalf. Retry with an increasing or variable delay between requests.
HTTP Status Code: 429
- ClientException
-
A generic client error. This error usually indicates that the request failed a validation check, such as when a downstream service rejects a configured value.
HTTP Status Code: 400
- ForbiddenException
-
You are not authorized to perform the requested operation.
HTTP Status Code: 403
- InvalidRequestException
-
The request is malformed or otherwise invalid. Verify the request and try again.
HTTP Status Code: 400
- ServiceException
-
An internal server error occurred while Image Builder processed the request. Retrying the request may succeed.
HTTP Status Code: 500
- ServiceUnavailableException
-
The service is unable to process your request at this time.
HTTP Status Code: 503
Examples
Get the runtime details of a workflow step
The following example retrieves runtime details for the step that launched the build instance during an image build, with the step's input parameters and output values returned as JSON-encoded strings.
Sample Request
GET /GetWorkflowStepExecution?stepExecutionId=step-2e6fef0d-657c-4b7e-8706-ff24da9afa01 HTTP/1.1
Sample Response
HTTP/1.1 200
Content-type: application/json
{
"requestId": "9ba63d27-9568-4ea3-bfed-6b1ad4c09200",
"stepExecutionId": "step-2e6fef0d-657c-4b7e-8706-ff24da9afa01",
"workflowBuildVersionArn": "arn:aws:imagebuilder:us-west-2:aws:workflow/build/build-image/1.0.3/1",
"workflowExecutionId": "wf-165b1cb6-3a62-4618-a021-94ddcbe32908",
"imageBuildVersionArn": "arn:aws:imagebuilder:us-west-2:111122223333:image/my-example-recipe/1.0.0/1",
"name": "LaunchBuildInstance",
"action": "LaunchInstance",
"status": "COMPLETED",
"inputs": "{\"waitFor\": \"ssmAgent\"}",
"outputs": "{\"instanceId\": \"i-1234567890abcdef0\"}",
"startTime": "2026-09-09T19:12:23.418Z",
"endTime": "2026-09-09T19:14:50.822Z",
"onFailure": "Abort",
"timeoutSeconds": 4500
}
See Also
For more information about using this API in one of the language-specific Amazon SDKs, see the following: